---
title: PaintWorklet
slug: Web/API/PaintWorklet
tags:
  - API
  - CSS
  - CSS Paint API
  - Houdini
  - Interface
  - Painting
  - Reference
  - Worklet
  - paintWorklet
---
<p>{{APIRef("CSS Painting API")}} {{seecompattable}}</p>

<p class="summary">The <strong><code>PaintWorklet</code></strong> interface of the {{domxref('CSS Painting API','','',' ')}} programmatically generates an image where a CSS property expects a file. Access this interface through {{DOMxRef("CSS.paintWorklet")}}.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref('PaintWorklet.devicePixelRatio')}}</dt>
 <dd>Returns the current device's ratio of physical pixels to logical pixels.</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<p>None.</p>

<h2 id="Methods">Methods</h2>

<p><em>This interface inherits methods from {{domxref('Worklet')}}.</em></p>

<dl>
 <dt>{{domxref('PaintWorklet.registerPaint()')}}</dt>
 <dd>Registers a class programmatically generate an image where a CSS property expects a file.</dd>
 <dt>{{domxref('Worklet.addModule', 'CSS.PaintWorklet.addModule()')}}</dt>
 <dd>The <code><a href="/en-US/docs/Web/API/Worklet/addModule">addModule()</a></code> method, inhertied from the <em>{{domxref('Worklet')}}</em> interface loads the module in the given JavaScript file and adds it to the current PaintWorklet.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following three examples go together to show creating, loading, and using a <code>PaintWorklet</code>.</p>

<h3 id="Create_a_PaintWorklet">Create a PaintWorklet</h3>

<p>The following shows an example worklet module. This should be in a separate js file. Note that <code>registerPaint()</code> is called without a reference to <code>PaintWorklet</code>.</p>

<pre class="brush: js">class CheckerboardPainter {
  paint(ctx, geom, properties) {
    // Use `ctx` as if it was a normal canvas
    const colors = ['red', 'green', 'blue'];
    const size = 32;
    for(let y = 0; y &lt; geom.height/size; y++) {
      for(let x = 0; x &lt; geom.width/size; x++) {
        const color = colors[(x + y) % colors.length];
        ctx.beginPath();
        ctx.fillStyle = color;
        ctx.rect(x * size, y * size, size, size);
        ctx.fill();
      }
    }
  }
}

// Register our class under a specific name
registerPaint('checkerboard', CheckerboardPainter);</pre>

<h3 id="Load_a_PaintWorklet">Load a PaintWorklet</h3>

<p>The following example demonstrates loading the above worklet from its js file and does so by feature detection.</p>

<pre class="brush: js">&lt;script&gt;
  if ('paintWorklet' in CSS) {
    CSS.paintWorklet.addModule('checkerboard.js');
  }
&lt;/script&gt;</pre>

<h3 id="Use_a_PaintWorklet">Use a PaintWorklet</h3>

<p>This example shows how to use a <code>PaintWorklet</code> in a stylesheet, including the simplest way to provide a fallback if <code>PaintWorklet</code> isn't supported. </p>

<pre class="brush: html">&lt;style&gt;
  textarea {
    background-image: url(checkerboard);
    background-image: paint(checkerboard);
  }
&lt;/style&gt;
&lt;textarea&gt;&lt;/textarea&gt;</pre>

<p>You can also use the {{cssxref('@supports')}} at-rule.</p>

<pre class="brush: css">@supports (background: paint(id)) {
  background-image: paint(checkerboard);
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('CSS Painting API','#paintworkletglobalscope','PaintWorkletGlobalScope')}}</td>
   <td>{{Spec2('CSS Painting API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PaintWorkletGlobalScope")}}</p>

<h2 id="See_Also">See Also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/CSS_Painting_API">CSS Painting API</a></li>
 <li><a href="/en-US/docs/Web/Houdini">Houdini APIs</a></li>
 <li><a href="/en-US/docs/Web/Houdini/learn">Houdini overview</a></li>
</ul>
